"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const promises_1 = __importDefault(require("fs/promises"));
const path_1 = __importDefault(require("path"));
const payload_openapi_1 = require("payload-openapi");
const load_1 = __importDefault(require("payload/dist/config/load"));
exports.default = (configPath, outputPath = 'doc/spec.json', options) => __awaiter(void 0, void 0, void 0, function* () {
    if (configPath) {
        process.env.PAYLOAD_CONFIG_PATH = configPath;
    }
    const config = yield (0, load_1.default)();
    const apiDocs = yield (0, payload_openapi_1.createDocument)(config, options);
    yield promises_1.default.mkdir(path_1.default.dirname(outputPath), { recursive: true });
    yield promises_1.default.writeFile(outputPath, JSON.stringify(apiDocs, null, 2), 'utf-8');
});
